﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Runtime.InteropServices;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace GetInputText
{
    public partial class MainForm : Form
    {
        public MainForm()
        {
            InitializeComponent();
            timer1.Enabled = true;
            timer1.Start();
        }

        const int WM_GETTEXT = 0x000D;
        const int WM_GETTEXTLENGTH = 0x000E;

        [DllImport("user32.dll", EntryPoint = "SendMessageA")]
        public static extern int SendMessage(IntPtr hwnd, int wMsg, int wParam, Byte[] lParam);

        [DllImport("user32.dll", EntryPoint="SendMessageA")]
        public static extern int SendMessage(IntPtr hwnd, int wMsg, int wParam, int lParam);

        [DllImport("user32.dll")]
        public static extern IntPtr GetForegroundWindow();

        [DllImport("User32.dll", EntryPoint = "FindWindowEx")]
        public static extern IntPtr FindWindowEx(IntPtr hwndParent, IntPtr hwndChildAfter, string lpClassName, string lpWindowName);

        /// <summary>
        /// 全局监听激活的应用输入框的内容
        /// </summary>
        /// <param name="hWnd"></param>
        public void GetTextFromForegroundWindow()
        {
            IntPtr hWnd = GetForegroundWindow();
            // Get the context of being typed
            IntPtr hEdit = FindWindowEx(hWnd, IntPtr.Zero, "Edit", null);
            if (hEdit != IntPtr.Zero)
            {
                // Get the length of the text
                int length = SendMessage(hEdit, WM_GETTEXTLENGTH, 0, 0);
                StringBuilder sb = new StringBuilder(length + 1);
                byte[] sbbyte=Encoding.Default.GetBytes(sb.ToString());
                SendMessage(
                    hEdit, WM_GETTEXT, sb.Capacity, sbbyte);
                string text = sbbyte.ToString();
                if (text.Length > 0 && text.IndexOf("/")==0)
                {
                    tbContent.Text = text;
                }
            }
            
        }

        /// 剪切板获取
        public String GetTextFromClipboard(){
            String text = "";
            if (Clipboard.ContainsText())
            {
                text = Clipboard.GetText();
            }
            if (text.Length > 0)
            {
                tbContent.Text = text;
            }
            return text;
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            // GetTextFromForegroundWindow();
            GetTextFromClipboard();
        }
    }
}
